



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>nuget的小Tips</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">nuget的小Tips</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-03 21:30:41 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h3>1.nuget常用命令</h3>
<pre class="prettyprint linenums"><code>nuget spec -a bin\Debug\DllName.dll -f //根据dll生成.nuspec文件，这样会生成无用的默认标签，比如licenseUrl、tags等<br />
cd [ProjectDir]<br />
nuget pack //建议根据项目生成nupkg，并从中解压出nuspec文件，这样生成的内容最精简

nuget pack DllName.nuspec -Build -Prop Configuration=Release //根据nuspec打包，但Build无效，不会生成项目<br />
nuget pack [ProjectName].csproj -Build -Prop Configuration=Release //根据csproj打包，会自动Build，自动根据*.nuspec修改元数据，自动根据*.packages修改Dependency

nuget push [ProjectName].*.nupkg [api-key] -S [PrivateNugetUrl]<br />
</code></pre>
<h3>2.添加pdb</h3>
<p>需要添加pdb方便调试的话，可以在解压出来的.nuspec中添加自定义&lt;files&gt;节，如下：</p>
<pre class="prettyprint linenums"><code>&lt;?xml version=&quot;1.0&quot;?&gt;<br />
&lt;package &gt;<br />
  &lt;metadata&gt;<br />
    &lt;id&gt;TestNuget&lt;/id&gt;<br />
    ...<br />
  &lt;/metadata&gt;<br />
  &lt;files&gt;<br />
  	&lt;!--&lt;file src=&quot;bin\Debug\TestNuget.dll&quot; target=&quot;lib\net45&quot; /&gt;--&gt;<br />
  	&lt;file src=&quot;bin\Debug\TestNuget.pdb&quot; target=&quot;lib\net45&quot; /&gt;<br />
  &lt;/files&gt;<br />
&lt;/package&gt;<br />
</code></pre>
<p>注意&lt;files&gt;节是在metadata的外面，dll文件默认就会打包，不需要重复添加。</p>
<h3>3.vs里自动发布</h3>
<p>当然要在vs里能一键发布才方便，最简单的方法是在外部工具里加个bat：</p>
<pre class="prettyprint linenums"><code>nuget pack %~1 -Build -Prop Configuration=Debug -o %~3<br />
nuget push %~3\%~2.*.nupkg [api-key] -S [PrivateNugetUrl]<br />
del %~3\%~2.*.nupkg /q<br />
</code></pre>
<p>然后在工具的参数里输入<code>$(ProjectDir)$(ProjectFileName) $(TargetName) $(ProjectDir)bin</code>分别作为1、2、3号参数。这里有3个小坑：</p>
<ul><li>$(ProjectDir)居然会输出2个&quot;\\&quot;，导致nuget报某些文件找不到，拼接之后的输出目录是正确的，无语了。</li>
<li>不支持选中多个项目发布，因为宏参数里没有<code>$(SelectedProjects)</code>之类的东东，<code>DTE.ActiveSolutionProjects</code>倒是可以，但是只能在插件里写，暂时没有想到好办法，知道的同学可以分享一下。</li>
<li>Debug和Release的区别，这一点其实不能算坑。Debug：不优化代码、调试信息=full；Release：优化、调试信息=pdb-only。不论代码是否优化，都可以从vs直接F5启动调试，但如果要附加调试(Attach to process)，就只能选Debug。关于full vs. pdb-only的区别，请参见<a href="https://msdn.microsoft.com/en-us/library/8cw0bt21%28VS.80%29.aspx" rel="external nofollow noreferrer">这里</a>。</li></ul>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q7o2ng8.html">SSISDB3：Environments 和 Environment Variables</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zz6e18.html">ASP&period;NET MVC应用程序执行过程分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q244ev8.html">挑选分组中top1</a>
		</li>
						<li><a href="https://www.batexi.com/a/96ojxny9.html">SqlSever基础 len函数 计算前后都有空格的字符串的长度时</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xgvwz8.html">30岁IT男连续工作一个月 突然失聪</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zj3p49.html">NSTimer定时器类</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1w7gx8.html">利用nf&lowbar;conntrack机制存储路由，省去每包路由查找</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv74nzq.html">python的生成器</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1dypx9.html">Windows10 磁盘活动时间百分之百导致系统卡顿解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1dyyj9.html">Linux主机规划与磁盘分区</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jdjjo8.html">adb shell top</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z426e9.html">【转】linux grep命令详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkr1ke8.html">&lpar;转&rpar;regex类（个人理解）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjejdk8.html">51Nod 1331 狭窄的通道</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r574x4q.html">JS setAttribute兼容</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvwwwj8.html">MySQL 添加索引，删除索引及其用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wkxdzq.html">PAT A1111 Online Map （30 分）&mdash;&mdash;最短路径，dijkstra</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pyxrz8.html">原生javascript封装的函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rn65omq.html">四、获取IP地址工具包</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rn6w7mq.html">将Excel的数据导入DataGridView中（转）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8mnnpj6q.html">z-score</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z11jvv9.html">Java源码初学&lowbar;HashSet&amp;amp&semi;LinkedHashSet</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xxnvn9.html">&lpar;四&rpar;Ubuntu 14&period;04 文件服务器--samba的安装和配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/90vve538.html">Java Socket编程----通信是这样炼成的</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k115y69.html">iOS项目中的version和build</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xxvjw9.html">C&plus;&plus;&mdash;复合类型</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xxd7v8.html">python模块以及导入出现ImportError&colon; No module named &amp;&num;39&semi;xxx&amp;&num;39&semi;问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xx7le8.html">android UI库</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z11xev9.html">Cmd Markdown 高阶语法手册</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdeevlv9.html">【新手练习】类似Path的按钮&comma;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
